Attribute VB_Name = "modControlWin"
Option Explicit

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
                ByVal hWnd As Long, _
                ByVal msg As Long, _
                wParam As Any, _
                lParam As Any) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" ( _
                ByVal hWnd As Long, _
                ByVal wMsg As Long, _
                ByVal wParam As Long, _
                ByVal lParam As Long) As Long

Public Const LB_GETCURSEL      As Long = &H188
Const LB_SETCURSEL      As Long = &H186
Const WM_LBUTTONDOWN    As Long = &H201
Const WM_LBUTTONUP      As Long = &H202
Const MK_LBUTTON        As Long = &H1
Const LB_GETITEMRECT    As Long = &H198&

'Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
'Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long

'Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Public Declare Function ShowWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Public Declare Function BringWindowToTop Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long

Public Const WM_COMMAND = &H111
Public Const WM_SETTEXT = &HC

Public intPrevListCount As Integer

'Public lngProcessID As Long
Public lngHandleEditor As Long

Public Const WM_USER = &H400
Public Const TBM_SETPOS = (WM_USER + 5)
Public Const BM_CLICK As Long = &HF5
Public Const WM_GETTEXT As Integer = &HD
Public Const WM_GETTEXTLENGTH As Long = &HE

Public Const GWL_ID = (-12)

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
    ByVal hWnd As Long, _
    ByVal nIndex As Long) As Long
    
Public Declare Function EnableWindow Lib "user32" (ByVal hWnd As Long, ByVal fEnable As Long) As Long

'Private Declare Function GetWindowThreadProcessId Lib "user32.dll" _
'(ByVal hwnd As Long, lpdwProcessId As Long) As Long


':BenMillard: Always on Top from MSDN:
'http://support.microsoft.com/kb/184297
Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const Flags = SWP_NOMOVE Or SWP_NOSIZE
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Function SetTopMostWindow(hWnd As Long, Topmost As Boolean) As Long
   If Topmost = True Then 'Make the window topmost
      SetTopMostWindow = SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, Flags)
   Else
      SetTopMostWindow = SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, Flags)
      SetTopMostWindow = False
   End If
End Function

Public Function EnumChildWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
    EnumChildWindowsProc = 1
    
    If ClassName(hWnd) = "ListBox" And Val(GetWindowLong(hWnd, GWL_ID)) = 1050 Then
        lngHandleEditor = hWnd
        EnumChildWindowsProc = 0
    End If
End Function

'Some of this function was from here: http://www.ex-designz.net/apidetail.asp?api_id=316
Public Function EnumWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
    EnumWindowsProc = 1 ' return value of 1 means continue enumeration

    If Left(LCase(WindowTitle(hWnd)), 11) = "gta2 editor" Or WindowTitle(hWnd) = vbNullString Then
        EnumChildWindows hWnd, AddressOf EnumChildWindowsProc, 1
    End If

End Function

Public Function WindowTitle(ByVal lHwnd As Long) As String
On Error GoTo oops

Dim slength As Long
Dim Buffer As String
Dim retval As Long

slength = GetWindowTextLength(lHwnd) + 1 ' get length of title bar text
If slength > 1 Then ' if return value refers to non-empty string
    Buffer = Space(slength) ' make room in the buffer
    retval = GetWindowText(lHwnd, Buffer, slength) ' get title bar text
    WindowTitle = Left(Buffer, slength - 1) ' display title bar text of enumerated window
    'frmHax.txtHistory.Text = frmHax.txtHistory.Text & WindowTitle & vbNewLine
End If
   
Exit Function

oops:

End Function

Public Function ClassName(ByVal lHwnd As Long) As String
On Error GoTo oops
Dim lLen As Long
Dim sBuf As String
    lLen = 260
    sBuf = String$(lLen, 0)
    lLen = GetClassName(lHwnd, sBuf, lLen)
    If (lLen <> 0) Then
        ClassName = Left$(sBuf, lLen)
    End If

Exit Function

oops:

End Function

'http://www.vbforums.com/showthread.php?t=563282 click a listbox item
Public Function clickListboxItem(handle As Long, index As Long)
    Debug.Print "clickListboxItem(" & handle & ", "; index & ")"
    
    Dim udtRECT As RECT
    
    'set currently selected
    SendMessage handle, LB_SETCURSEL, ByVal CLng(index), ByVal CLng(0)
    
    'get currently selected
    index = SendMessage(handle, LB_GETCURSEL, ByVal CLng(0), ByVal CLng(0))
    
    'get rectangle
    SendMessage handle, LB_GETITEMRECT, ByVal CLng(index), udtRECT
    
    'send WM_LBUTTONDOWN
    Call PostMessage(handle, WM_LBUTTONDOWN, ByVal CLng(MK_LBUTTON), MakeDWord(udtRECT.Left, udtRECT.Top))
    Call PostMessage(handle, WM_LBUTTONUP, ByVal CLng(MK_LBUTTON), MakeDWord(udtRECT.Left, udtRECT.Top))
End Function

Public Function MakeDWord(ByVal LoWord As Integer, ByVal HiWord As Integer) As Long
    MakeDWord = (HiWord * &H10000) Or (LoWord And &HFFFF&)
End Function


