Attribute VB_Name = "modDeclares"
Option Explicit

Public Declare Sub ReleaseCapture Lib "user32" ()
'Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Public pSetting As Variant

Public Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type tPal
    Info(255) As RGBQUAD
End Type

Public Type tTile
    Info(63) As String * 64
End Type

Public Type tSprx
    offset As Long
    Width As Byte
    Height As Byte
    Pad As Integer
End Type

Public Type tDelx
    iSpriteNum As Integer
    iDelCount As Byte
    iPad As Byte
    iData() As Integer
End Type

Public Type tDels
    iOffset As Integer
    iLength As Byte
    iData As String
End Type

Public Type tSprb
    iCar As Integer
    iPed As Integer
    iCode_Obj As Integer
    iMap_Obj As Integer
    iUser As Integer
    iFont As Integer
End Type

Public Type tPalb
    pals(7) As Integer
End Type

Public Type tFonb
    iFontCount As Integer
    iBase() As Integer
End Type
    
Public Type tDoor
    iX As Byte
    iY As Byte
End Type

Public Type tCari
    iModel As Byte
    iSprite As Byte
    iWidth As Byte
    iHeight As Byte
    iNum_Remaps As Byte
    iPassengers As Byte
    iWreck As Byte
    iRating As Byte
    iFront_Wheel_Offset As Byte
    iRear_Wheel_Offset As Byte
    iFront_Window_Offset As Byte
    iRear_Window_Offset As Byte
    iInfo_flags As Byte
    iInfo_flags_2 As Byte
    iRemap() As Byte
    iNum_Doors As Byte
    tDoors() As tDoor
End Type

Public sTempDir As String
Public sGTA2Dir As String
Public sGTA2DataDir As String
Public sComments(22) As String

'STY Varibles
Public Dels As String
Public PPal() As tPal
Public Palx() As Integer
Public Delx() As tDelx
Public Palb As tPalb
Public Sprb As tSprb
Public Cari() As tCari
Public Recy() As Byte
Public Fonb As tFonb

Public Sub wDragWindow(fForm As Form)
    ReleaseCapture
    SendMessage fForm.hWnd, &HA1, 2, 0&
End Sub

Public Function GetVal(sStr) As Integer
    Dim tmp As String
    Dim t2 As String
    Dim i As Long
    tmp = "&h"
    t2 = StrRev(sStr)
    For i = 1 To Len(t2)
        tmp = tmp & Right("0" + Hex(Asc(Mid(t2, i, 1))), 2)
    Next
    GetVal = Val(tmp)
End Function

Public Function StrRev(sStr) As String
    Dim i As Long
    Dim tmp As Long
    For i = Len(sStr) To 1 Step -1
        tmp = tmp & Mid(sStr, i, 1)
    Next
    StrRev = tmp
End Function

Public Sub DumpDelx()
  Dim i As Long
  Dim j As Long
  Open "c:\temp.txt" For Output As 1
    For i = 0 To UBound(Delx)
      Print #1, "Sprite Number: " & Delx(i).iSpriteNum
      Print #1, "Delta Count: " & Delx(i).iDelCount
      For j = 0 To Delx(i).iDelCount - 1
        Print #1, Chr(9) & "Delta " & j & " Length: " & Delx(i).iData(j)
      Next
    Next
  Close 1
End Sub
