Attribute VB_Name = "modGTA2"
Option Explicit

Public Sub CenterMe(frm As Form)
    frm.Left = (Screen.Width / 2) - (frm.Width / 2)
    frm.Top = (Screen.Height / 2) - (frm.Height / 2)
End Sub

Public Sub ShowProgress(Min, Max, msg)
    On Error Resume Next
    With frmProgress
        .pbar.Max = Max
        .pbar.Min = Min
        .l = msg
        .Show
    End With
    On Error GoTo 0
End Sub

Public Sub UpDateProgress(Value, msg)
    If frmProgress.pbar.Value <> Value And Value < frmProgress.pbar.Max Then frmProgress.pbar.Value = Value
    If frmProgress.l <> msg Then frmProgress.l = msg
    DoEvents
End Sub

Public Sub CloseProgress()
    Unload frmProgress
End Sub

Public Sub LoadSettings()
    sGTA2Dir = GetSetting(App.Title, "Settings", "Path")
    sGTA2DataDir = sGTA2Dir & "data\"
    sTempDir = GetSetting(App.Title, "Settings", "TempPath")
End Sub

Public Sub SaveSettings()
    sGTA2DataDir = sGTA2Dir & "data\"
    SaveSetting App.Title, "Settings", "Path", sGTA2Dir
    SaveSetting App.Title, "Settings", "TempPath", sTempDir
End Sub
'Public Function ShowSetting(Min, Max, Info, Value, idx) As Variant
'    Load frmSetVal
'    If idx > 4 Then
'        frmSetVal.sVal.Max = Max
'        frmSetVal.sVal.Min = Min
'        frmSetVal.sVal.Value = Value * 1000
'    Else
'        frmSetVal.sVal.Enabled = False
'    End If
'    frmSetVal.tVal = Value
'    frmSetVal.lblinfo = Info
'    pSetting = Value
'    frmSetVal.Show vbModal
'    ShowSetting = pSetting
'End Function
